task main()
{
	float offset=0;
	repeat(1000)
	{
		offset=getGyroRate(S2)+offset;
		sleep(1);
	}
	offset=offset/1000;
	playSound(soundBeepBeep);
	sleep(4000);
	float Encoder,enc_b,enc_c,ang_vel,enc,ang=0,e,u,v,k1=1.5,t=0.004,k2=15,k3=0.3,speed,enc_old=0,k4=0.25,ku=3,z=0.03,m,to;
	resetMotorEncoder(motorB);
	resetMotorEncoder(motorC);
	while (true)
	{
		e=getColorReflected(S3)-getColorReflected(S4);
		m=getColorReflected(S3)+getColorReflected(S4)/2;
		if(m<8)
			to=0.02;
		else
			to=0;
		u=e*ku;
		z=0.03-abs(e)*0.0015-to;
		if(z<0.00)
			z=0.00;
		ang_vel=getGyroRate(S2)-offset;
		ang=ang+ang_vel*t;
		ang=ang-z;
		enc=(nMotorEncoder[motorB]+nMotorEncoder[motorC])/2;
		speed=(enc-enc_old)/t;
		v=ang_vel*k1+ang*k2+enc*k3+speed*k4;
		setMotorSync(motorB,motorC, u, v);
		enc_old=enc;
		sleep(4);



		if(getIRDistance(S1)<50)
		{
			playSound(soundBeepBeep);
			repeat(500)
			{
				u=10;
				ang_vel=getGyroRate(S2)-offset;
				ang=ang+ang_vel*t;
				ang=ang-0.006;
				enc=(nMotorEncoder[motorB]+nMotorEncoder[motorC])/2;
				speed=(enc-enc_old)/t;
				v=ang_vel*k1+ang*k2+enc*k3+speed*k4;
				setMotorSync(motorB,motorC,u , v);
				enc_old=enc;
				sleep(4);
			}
			playSound(soundBeepBeep);
			enc_b=nMotorEncoder[motorB];
			enc_c=nMotorEncoder[motorC];
			while(nMotorEncoder[motorB]-enc_b<400)
			{
				u=20;
				ang_vel=getGyroRate(S2)-offset;
				ang=ang+ang_vel*t;
				ang=ang-0.004;
				enc=(nMotorEncoder[motorB]+nMotorEncoder[motorC])/2;
				speed=(enc-enc_old)/t;
				v=ang_vel*k1+ang*k2+enc*k3+speed*k4;
				setMotorSync(motorB,motorC,u, v);
				enc_old=enc;
				sleep(4);

			}
			enc_c=nMotorEncoder[motorC];
			u=0;
			while((nMotorEncoder[motorC]-enc_c) <300)
			{
				u=0;
				ang_vel=getGyroRate(S2)-offset;
				ang=ang+ang_vel*t;
				ang=ang-0.008;
				enc=(nMotorEncoder[motorB]+nMotorEncoder[motorC])/2;
				speed=(enc-enc_old)/t;
				v=ang_vel*k1+ang*k2+enc*k3+speed*k4;
				setMotorSync(motorB,motorC,u, v);
				enc_old=enc;
				sleep(4);

			}

			enc_c=nMotorEncoder[motorC];
			u=0;
			while(getColorReflected(S3)>3||getColorReflected(S4)>3)
			{
				u=20;
				ang_vel=getGyroRate(S2)-offset;
				ang=ang+ang_vel*t;
				ang=ang-0.02;
				enc=(nMotorEncoder[motorB]+nMotorEncoder[motorC])/2;
				speed=(enc-enc_old)/t;
				v=ang_vel*k1+ang*k2+enc*k3+speed*k4;
				setMotorSync(motorB,motorC,-u, v);
				enc_old=enc;
				sleep(4);

			}
			playSound(soundBeepBeep);
			enc_b=nMotorEncoder[motorB];
			while(nMotorEncoder[motorB]-enc_b<300)
			{
				u=40;
				ang_vel=getGyroRate(S2)-offset;
				ang=ang+ang_vel*t;
				ang=ang-0.001;
				enc=(nMotorEncoder[motorB]+nMotorEncoder[motorC])/2;
				speed=(enc-enc_old)/t;
				v=ang_vel*k1+ang*k2+enc*k3+speed*k4;
				setMotorSync(motorB,motorC,u, v);
				enc_old=enc;
				sleep(4);

			}
		}
	}
}
